#include <windows.h>
#include <string.h>
#include <commdlg.h>
//#include <stdlib.h>
#include "vbdialog.h"

#define MsgBox(lpszText) \
        MessageBox(NULL, lpszText, "VBDIALOG.DLL", \
        MB_OK | MB_ICONEXCLAMATION | MB_TASKMODAL)

#define InfoBox(lpszText,lpszTitel) \
        MessageBox(NULL, lpszText, lpszTitel, \
        MB_OK | MB_ICONINFORMATION | MB_TASKMODAL)

HANDLE      hInst;          // Instanzhandle der DLL
HWND        hDlg;           // Handle des nichtmodalen Dialogfelds
#define     DLL_VERSION 1

/********************************************************************/
/*  Windows Verwaltung                                              */
/********************************************************************/
int FAR PASCAL LibMain (HANDLE hModule, WORD wDataSeg, WORD cbHeapSize,
    LPSTR lps)
{
    hInst = hModule;
    return (TRUE);
}

int FAR PASCAL _WEP (int nExitType)
{
    return (TRUE);
}

/********************************************************************/
/*  DLL Funktionen                                                  */
/********************************************************************/
int FAR PASCAL DLLGetVersion (void)
{
    return (DLL_VERSION);
}

void FAR PASCAL DLLGetAbout (LPSTR lps)
{
    static char msg[20];
    wsprintf(msg, "Version: %d", DLL_VERSION);
    InfoBox(msg,lps);
}


int FAR PASCAL DLLSaveFileN (cmdialg far *MyStruct)
{
    OPENFILENAME ofn;
    int ret = 0;

    //ofn.blaMyStruct->DlgArt;  wird nicht in ofn benoetigt
    ofn.hwndOwner = MyStruct->DlgParent;
    //ofn.hInstance = MyStruct->DlgInst;
    ofn.lpstrCustomFilter = "";//MyStruct->DlgFilter[1];
    ofn.lpstrFilter = MyStruct->DlgFilters;
    ofn.nMaxCustFilter = sizeof(MyStruct->DlgFilters);//MyStruct->DlgMaxFilter;
    ofn.nFilterIndex = MyStruct->DlgFilterIndex;
    ofn.lpstrFile = MyStruct->DlgFileName;
    ofn.nMaxFile = sizeof(MyStruct->DlgFileName);//MyStruct->DlgFileNameL;
    ofn.lpstrFileTitle = MyStruct->DlgFileTitle;
    ofn.nMaxFileTitle = sizeof(MyStruct->DlgFileTitle);//MyStruct->DlgFileTitleL;
    ofn.lpstrInitialDir = MyStruct->DlgInitDir;
    ofn.lpstrTitle = MyStruct->DlgTitel;
    ofn.Flags = MyStruct->DlgFlags;
    ofn.nFileOffset = MyStruct->DlgFileOffset;
    ofn.nFileExtension = MyStruct->DlgFileExt;
    ofn.lpstrDefExt = MyStruct->DlgDefaultExt;
    ofn.Flags=OFN_SHOWHELP|OFN_OVERWRITEPROMPT;
    ofn.lStructSize = sizeof(ofn);

    if (GetSaveFileName(&ofn))
    {
        MyStruct->DlgFilterIndex=ofn.nFilterIndex;
        //MyStruct->DlgFileName=ofn.lpstrFile;
        ret = -1;
    }
    return (ret);
}

int FAR PASCAL DLLSaveFile (int MyWindow, LPSTR szFilter, int far *FilterIndex, LPSTR szTitel, LPSTR stFileName, LPSTR stFilePath)
{
    int rc;

    OPENFILENAME ofn;
    char szDirName[256];
    char szFile[256], szFileTitle[256];
    UINT  i, cbString;
    char  chReplace;    /* string separator for szFilter */
    //char  szFilter[256];
    HFILE hf;

    GetWindowsDirectory(szDirName, sizeof(szDirName));

    szFile[0] = '\0';

    ofn.hwndOwner = MyWindow;
    //ofn.hInstance;
    ofn.lpstrFilter=szFilter;
    ofn.lpstrCustomFilter="";//szFilter;//"Dokumentschreibstauinformationsdatei *.doc";
    ofn.nMaxCustFilter=sizeof(ofn.lpstrCustomFilter);
    ofn.nFilterIndex=*FilterIndex;//sizeof(ofn.lpstrFilter);
    ofn.lpstrFile=szFile;
    ofn.nMaxFile=sizeof(szFile);
    ofn.lpstrFileTitle=szFileTitle;
    ofn.nMaxFileTitle=sizeof(szFileTitle);
    ofn.lpstrInitialDir=szDirName;
    ofn.lpstrTitle=szTitel;
    ofn.Flags=OFN_SHOWHELP|OFN_OVERWRITEPROMPT;
    //ofn.nFileOffset;
    //ofn.nFileExtension;
    ofn.lpstrDefExt="BMP";
    //ofn.lCustData;
    //ofn.(CALLBACK* lpfnHook) (HWND, UINT, WPARAM, LPARAM);
    //ofn.lpTemplateName;

    ofn.lStructSize = sizeof(OPENFILENAME);
    if (GetSaveFileName(&ofn)){


    *FilterIndex=ofn.nFilterIndex;
    stFilePath=ofn.lpstrFile;
    }
    return (-1);
}